Attribute VB_Name = "cm"
'**********************************'
' :   '
'**********************************'

'  
  Option Explicit '   
  
' :    
  Const STARTF_FORCEOFFFEEDBACK = &H80
  Const STARTF_FORCEONFEEDBACK = &H40
  Const STARTF_RUNFULLSCREEN = &H20
  Const STARTF_USECOUNTCHARS = &H8
  Const STARTF_USEFILLATTRIBUTE = &H10
  Const STARTF_USEPOSITION = &H4
  Const STARTF_USESHOWWINDOW = &H1
  Const STARTF_USESIZE = &H2
  Const STARTF_USESTDHANDLES = &H100
  Const SW_HIDE = 0
  Const SW_SHOWNORMAL = 1
  Const SW_SHOWMINIMIZED = 2
  Const SW_MAXIMIZE = 3
  Const SW_SHOWMAXIMIZED = 3
  Const SW_SHOWNOACTIVATE = 4
  Const SW_SHOW = 5
  Const SW_MINIMIZE = 6
  Const SW_SHOWMINNOACTIVE = 7
  Const SW_SHOWNA = 8
  Const SW_RESTORE = 9
  Const SW_SHOWDEFAULT = 10
  Const INFINITE = &HFFFF
  
'  :    
  Private Type PROCESS_INFORMATION
      hProcess As Long
      hThread As Long
      dwProcessId As Long
      dwThreadId As Long
  End Type
  Private Type STARTUPINFO
      cb As Long
      lpReserved As String
      lpDesktop As String
      lpTitle As String
      dwX As Long
      dwY As Long
      dwXSize As Long
      dwYSize As Long
      dwXCountChars As Long
      dwYCountChars As Long
      dwFillAttribute As Long
      dwFlags As Long
      wShowWindow As Integer
      cbReserved2 As Integer
      lpReserved2 As Long
      hStdInput As Long
      hStdOutput As Long
      hStdError As Long
  End Type
  
' :    
  Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
  Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
  Private Declare Function CloseHandle Lib "kernel32" (ByVal lngHandle As Long) As Long
  
' :    
' strPath - 
Public Function PathCorrect(strPath As String) As String
  ' 
    If VBA.Len(strPath) > 0 Then
      If VBA.Right(strPath, 1) = "\" Then
        PathCorrect = strPath
      Else
        PathCorrect = strPath & "\"
      End If
    Else
      PathCorrect = strPath
    End If
End Function

' :    ,   
' ComLine -  
' DefaultDir -  -
' ShowFlag -   
' [{lngHandle}] -   (   )
'     
Public Function RunAndWait(ComLine As String, DefaultDir As String, ShowFlag As Long, Optional lngHandle) As Boolean
  ' 
    Dim si As STARTUPINFO         '    
    Dim pi As PROCESS_INFORMATION '    
  ' 
    '  
    si.wShowWindow = ShowFlag
    si.dwFlags = STARTF_USESHOWWINDOW
    '  
    If CreateProcess(vbNullString, ComLine, ByVal 0&, ByVal 0&, False, 0, ByVal 0&, DefaultDir, si, pi) Then
      '   
      If Not VBA.IsMissing(lngHandle) Then lngHandle = pi.hProcess
      '   
      WaitForSingleObject pi.hProcess, INFINITE
      '  
      CloseHandle pi.hProcess
      '    
      RunAndWait = True
      '   
      Exit Function
    End If
    '    
    RunAndWait = False
End Function

' :       -   
' strPath -   
'   
Public Function DirCorrect(strPath As String) As String
  ' 
    Dim strText As String '     
    Dim intLen As Integer '  
  ' 
    '      
    strText = VBA.Trim(strPath)
    '   
    intLen = VBA.Len(strText)
    ' ,   
    If intLen = 0 Then
      '   
      DirCorrect = ""
      '   
      Exit Function
    End If
    '  
    If VBA.Right(strText, 1) = "\" Then strText = VBA.Left(strText, intLen - 1)
    '  
    DirCorrect = strText
End Function

' :      
Public Function sGetPath(strPath As String) As String
  ' 
    Dim intPos As Integer '    
  ' 
    If strPath = "" Then
      sGetPath = ""
    Else
      intPos = InStrBack(strPath, "\")
      If intPos = 0 Then
        sGetPath = strPath
      Else
        sGetPath = VBA.Left(strPath, VBA.Len(strPath) - intPos + 1)
      End If
    End If
End Function

' :       
Public Function InStrBack(strLine, strFind) As Integer
  ' 
    Dim lngSym As Long        '  
    Dim strBack As String     '     
    Dim strFindBack As String '     
  ' 
    ' ,   
    If VBA.Len(strLine) = 0 Then
      '   
      InStrBack = 0
      '   
      Exit Function
    End If
    '   
    strBack = ""
    '   
    strFindBack = ""
    '    
    For lngSym = VBA.Len(strLine) To 1 Step -1
      strBack = strBack & VBA.Mid(strLine, lngSym, 1)
    Next
    '    
    For lngSym = VBA.Len(strFind) To 1 Step -1
      strFindBack = strFindBack & VBA.Mid(strFind, lngSym, 1)
    Next
    '      
    InStrBack = VBA.InStr(strBack, strFindBack)
End Function

' :    
' [blnCase]=True -  
Public Function sSubToSub(strString As String, strSubOld As String, strSubNew As String, Optional blnCase As Boolean = True) As String
  ' 
    Dim lngLen As Long    '   
    Dim lngLenOld As Long '   
    Dim lngLenNew As Long '   
    Dim lngBegin As Long  '   
    Dim lngPos As Long    '   
    Dim strRez As String  '  
  ' 
    '   
    strRez = strString
    ' ,   
    If strSubOld = "" Then GoTo SubExit
    '    
    lngLen = VBA.Len(strRez)
    ' ,      
    If lngLen = 0 Then
      '   
      strRez = ""
      '    
      GoTo SubExit
    End If
    '    
    lngLenOld = VBA.Len(strSubOld)
    ' ,        
    If lngLenOld > lngLen Then
      '   
      sSubToSub = strRez
      '   
      Exit Function
    End If
    '    
    lngLenNew = VBA.Len(strSubNew)
    '    
    lngBegin = 1
    '  
    Do While True
      '   
      lngPos = VBA.InStr(lngBegin, strRez, strSubOld, VBA.IIf(blnCase, vbBinaryCompare, vbTextCompare))
      '   ,   
      If lngPos = 0 Then Exit Do
      '  
      strRez = VBA.Left(strRez, lngPos - 1) & strSubNew & VBA.Right(strRez, lngLen - lngPos - lngLenOld + 1)
      '    
      lngLen = VBA.Len(strRez)
      '     
      lngBegin = lngPos + lngLenNew
    Loop
SubExit:
    '  
    sSubToSub = strRez
End Function

' :    
' varArr -   Variant
' [intLevel]=1 - 
Public Function LenArray(ByRef varArr As Variant, Optional intLevel As Integer = 1) As Long
  ' 
    Dim lngCount As Long '  
  ' 
    '   
    lngCount = -1
    '  
    On Error Resume Next
    '   
    lngCount = UBound(varArr, intLevel) - LBound(varArr, intLevel) + 1
    '  
    On Error GoTo 0
    '  
    LenArray = VBA.IIf(lngCount = -1, 0, lngCount)
End Function
