Attribute VB_Name = "cm_RegEdit"
'***************************************'
' :      '
'***************************************'

'  
  Option Explicit '   

' :   
  Private Const ERROR_NONE = 0
  Private Const ERROR_BADDB = 1
  Private Const ERROR_BADKEY = 2
  Private Const ERROR_CANTOPEN = 3
  Private Const ERROR_CANTREAD = 4
  Private Const ERROR_CANTWRITE = 5
  Private Const ERROR_OUTOFMEMORY = 6
  Private Const ERROR_INVALID_PARAMETER = 7
  Private Const ERROR_ACCESS_DENIED = 8
  Private Const ERROR_INVALID_PARAMETERS = 87
  Private Const ERROR_NO_MORE_ITEMS = 259
  Private Const KEY_ALL_ACCESS = &H3F
  Private Const REG_OPTION_NON_VOLATILE = 0
  
'  :    
  Public Enum EnumRegEditTypeValue
    enuREG_SZ = 1
    enuREG_EXPAND_SZ = 2
    enuREG_BINARY = 3
    enuREG_DWORD = 4
    enuREG_MULTI_SZ = 7
  End Enum

'  :  
  Public Enum EnumRegEditSect
    enuHKEY_LOCAL_MACHINE = &H80000002
    enuHKEY_CLASSES_ROOT = &H80000000
    enuHKEY_CURRENT_USER = &H80000001
    enuHKEY_USERS = &H80000003
  End Enum

' :    
  Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal HKEY As Long) As Long
  Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal HKEY As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
  Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String, phkResult As Long) As Long
  Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal HKEY As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
  Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
  Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
  Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
  Private Declare Function RegQueryValueExBinary Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Byte
  Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
  Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
  Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long
  Private Declare Function RegDeleteKey& Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String)
  Private Declare Function RegDeleteValue& Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal HKEY As Long, ByVal lpValueName As String)

' :   
' enuSect -   
' strKey -   
' strName -  
'  
Public Function QueryValue(enuSect As EnumRegEditSect, strKey As String, strName As String) As Variant
  ' 
    Dim blnRes As Boolean   '   
    Dim lngKey As Long      '  
    Dim lngSize As Long     '  
  ' : 
    Dim lngValue As Long    '  
    Dim strValue As String  '  
    Dim varValue As Variant ' 
    Dim bytValue() As Byte  '  
  ' :  
    Dim enuType As EnumRegEditTypeValue '   
  ' 
    '    
    blnRes = False
    '   
    lngKey = 0
    '  
    varValue = Empty
    '  
    On Error GoTo SubError
    '  
    If RegOpenKeyEx(enuSect, strKey, 0, KEY_ALL_ACCESS, lngKey) <> 0 Then GoTo SubExit
    '      
    If RegQueryValueExNULL(lngKey, strName, 0&, enuType, 0&, lngSize) <> 0 Then GoTo SubExit
    '  
    Select Case enuType
      Case enuREG_EXPAND_SZ, enuREG_SZ, enuREG_MULTI_SZ
        '  
        strValue = VBA.String(lngSize, 0)
        '  
        If RegQueryValueExString(lngKey, strName, 0&, enuType, strValue, lngSize) <> 0 Then GoTo SubExit
        '  
        varValue = VBA.Left$(cm.sSubToSub(VBA.CStr(strValue), VBA.Chr(0), ""), lngSize)
      Case enuREG_DWORD
        '  
        If RegQueryValueExLong(lngKey, strName, 0&, enuType, lngValue, lngSize) <> 0 Then GoTo SubExit
        '  
        varValue = lngValue
      Case enuREG_BINARY
        '   
        varValue = VBA.Space(lngSize)
        '  
        If RegQueryValueEx(lngKey, strName, 0&, enuType, ByVal 0&, lngSize) <> 0 Then GoTo SubExit
        '    
        ReDim bytValue(0 To lngSize - 1) As Byte
        '   
        If RegQueryValueEx(lngKey, strName, 0&, enuType, bytValue(0), lngSize) <> 0 Then GoTo SubExit
        '  
        varValue = bytValue
      Case Else
        GoTo SubExit
    End Select
Continue:
    '    
    blnRes = True
    '  
    GoTo SubExit
SubError:
    '   
    Resume SubExit
SubExit:
    '  
    CloseKey lngKey
    '  
    If blnRes Then QueryValue = varValue
End Function

' :  
' lngKey -  
Private Sub CloseKey(lngKey As Long)
  ' 
    ' ,    
    If lngKey = 0 Then Exit Sub
    '  
    On Error Resume Next
    '  
    RegCloseKey lngKey
    '  
    On Error GoTo 0
End Sub

' :   
Public Function DeleteValue(lPredefinedKey As Long, sKeyName As String, sValueName As String)
  ' 
    Dim lRetVal As Long
    Dim HKEY As Long
  ' 
    lRetVal = RegOpenKeyEx(lPredefinedKey, sKeyName, 0, KEY_ALL_ACCESS, HKEY)
    lRetVal = RegDeleteValue(HKEY, sValueName)
    RegCloseKey (HKEY)
End Function

' :    
Private Function SetValueEx(ByVal HKEY As Long, sValueName As String, lType As Long, vValue As Variant) As Long
  ' 
    Dim lValue As Long
    Dim sValue As String
  ' 
    Select Case lType
      Case enuREG_SZ, enuREG_EXPAND_SZ, enuREG_MULTI_SZ
        sValue = vValue
        SetValueEx = RegSetValueExString(HKEY, sValueName, 0&, lType, sValue, Len(sValue))
      Case enuREG_DWORD
        lValue = vValue
        SetValueEx = RegSetValueExLong(HKEY, sValueName, 0&, lType, lValue, 4)
    End Select
End Function

' :    
' enuSect -   
' strKey -   
' strName -  
' varValue - 
' enuType -  
'    
Public Function SetKeyValue(enuSect As EnumRegEditSect, strKey As String, strName As String, varValue As Variant, enuType As EnumRegEditTypeValue) As Boolean
  ' 
    Dim blnRes As Boolean '   
    Dim lngKey As Long    '  
  ' 
    '    
    blnRes = False
    '   
    lngKey = 0
    ' ,      
    If QueryValue(enuSect, strKey, strName) = varValue Then GoTo Continue
    '  
    If RegOpenKeyEx(enuSect, strKey, 0, KEY_ALL_ACCESS, lngKey) <> 0 Then GoTo SubExit
    '  
    If SetValueEx(lngKey, strName, enuType, varValue) <> 0 Then GoTo SubExit
Continue:
    '    
    blnRes = True
SubExit:
    '  
    CloseKey lngKey
    '  
    SetKeyValue = blnRes
End Function

' :  
' enuSect -  
' strKey -   
'    
Public Function CreateNewKey(enuSect As EnumRegEditSect, strKey As String) As Boolean
  ' 
    Dim blnRes As Boolean '   
    Dim lngKey As Long    '  
    Dim lngRet As Long    ' 
  ' 
    '    
    blnRes = False
    ' ,   
    If TestKey(enuSect, strKey) Then GoTo Continue
    '  
    If RegCreateKeyEx(enuSect, strKey, 0&, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, lngKey, lngRet) <> 0 Then GoTo SubExit
    '  
    RegCloseKey lngKey
Continue:
    '    
    blnRes = True
SubExit:
    '  
    CreateNewKey = blnRes
End Function

' :  
Public Function DeleteKey(lPredefinedKey As Long, sKeyName As String)
  ' 
    Dim lRetVal As Long
  ' 
    lRetVal = RegDeleteKey(lPredefinedKey, sKeyName)
End Function

' :   
' enuSect -   
' strKey -   
'    
Public Function TestKey(enuSect As EnumRegEditSect, strKey As String) As Boolean
  ' 
    Dim lngRes As Long '  
  ' 
    '   
    TestKey = (RegOpenKey(enuSect, strKey, lngRes) = 0)
End Function

